package com.mytutorials.design_patterns.iterator.impl;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import com.mytutorials.design_patterns.iterator.SongIterator;
import com.mytutorials.design_patterns.iterator.context.SongInfo;

public class SongsOfThe90s implements SongIterator {

	// Create a Hashtable with an int as a key and SongInfo
	// Objects

	private Map<Integer, SongInfo> bestSongs = new Hashtable<Integer, SongInfo>();

	// Will increment the Hashtable key

	int hashKey = 0;

	public SongsOfThe90s() {

		addSong("Losing My Religion", "REM", 1991);
		addSong("Creep", "Radiohead", 1993);
		addSong("Walk on the Ocean", "Toad The Wet Sprocket", 1991);

	}

	// Add a new SongInfo Object to the Hashtable and then increment
	// the Hashtable key

	public void addSong(String songName, String bandName, int yearReleased) {

		SongInfo songInfo = new SongInfo(songName, bandName, yearReleased);

		bestSongs.put(hashKey, songInfo);

		hashKey++;

	}

	// This is replaced by the Iterator
	// Return a Hashtable full of SongInfo Objects

	public Map<Integer, SongInfo> getBestSongs() {

		return bestSongs;

	}

	// NEW By adding this method I'll be able to treat all
	// collections the same

	public Iterator<SongInfo> createIterator() {
		// TODO Auto-generated method stub
		return bestSongs.values().iterator();
	}

}
