package com.mytutorials.design_patterns.factory.creator;

import com.mytutorials.design_patterns.factory.product.BigUFOEnemyShip;
import com.mytutorials.design_patterns.factory.product.EnemyShip;
import com.mytutorials.design_patterns.factory.product.RocketEnemyShip;
import com.mytutorials.design_patterns.factory.product.UFOEnemyShip;

public class EnemyShipFactory {

	// This could be used as a static method if we

	// are willing to give up subclassing it

	public EnemyShip makeEnemyShip(String newShipType) {

		EnemyShip newShip = null;

		if (newShipType.equals("U")) {

			return new UFOEnemyShip();

		} else

		if (newShipType.equals("R")) {

			return new RocketEnemyShip();

		} else

		if (newShipType.equals("B")) {

			return new BigUFOEnemyShip();

		} else
			return null;

	}
}
